diff --git a/src/tools/msvc/Mkvcbuild.pm b/src/tools/msvc/Mkvcbuild.pm
index 3d929e6..ab65fa3 100644
--- a/src/tools/msvc/Mkvcbuild.pm
+++ b/src/tools/msvc/Mkvcbuild.pm
@@ -71,7 +71,7 @@ my $frontend_extrasource = {
 	    'src/bin/psql/psqlscan.l' ] };
 my @frontend_excludes = (
 	'pgevent',     'pg_basebackup', 'pg_rewind', 'pg_dump',
-	'pg_xlogdump', 'scripts');
+	'pg_xlogdump', 'scripts',       'pgbench');
 
 sub mkvcbuild
 {
@@ -674,6 +674,11 @@ sub mkvcbuild
 	}
 	$pg_xlogdump->AddFile('src/backend/access/transam/xlogreader.c');
 
+	# fix up pgbench once it's been set up
+	# we're borrowing psqlscan.c from psql, so grab it from the correct place
+	my $pgbench = AddSimpleFrontend('pgbench');
+	$pgbench->ReplaceFile('src/bin/pgbench/psqlscan.c', 'src/bin/psql/psqlscan.c');
+
 	$solution->Save();
 	return $solution->{vcver};
 }
